/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.95 Revision 1.125
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.95 2011/10/16 09:59:39 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.125 2012/04/19 14:52:12 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 IUSE="+exceptions" 45 IUSE+=" +exceptions"
23else
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
26 50
27HOMEPAGE="http://qt.nokia.com/" 51DEPEND="dev-util/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 52if [[ ${QT4_BUILD_TYPE} == live ]]; then
29 53 DEPEND+=" dev-lang/perl"
30LICENSE="|| ( LGPL-2.1 GPL-3 )" 54fi
31IUSE+=" debug pch aqua"
32 55
33RDEPEND=" 56RDEPEND="
34 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
35 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
36 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
37 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
38 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
39 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
40 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
41 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
42 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
43 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
44 !<x11-libs/qt-multimedia-${PV} 71 !<x11-libs/qt-multimedia-${PV}
45 !>x11-libs/qt-multimedia-${PV}-r9999 72 !>x11-libs/qt-multimedia-${PV}-r9999
46 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
47 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
48 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
49 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
50 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
51 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
52 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
65 94
66S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
67 96
68# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 98# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 102
74 # Protect users by not allowing downgrades between releases 103 # Protect users by not allowing downgrades between releases
75 # Downgrading revisions within the same release should be allowed 104 # Downgrading revisions within the same release should be allowed
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then 105 if has_version '>'${CATEGORY}/${P}-r9999; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
78 eerror "Sanity check to keep you from breaking your system:" 108 eerror "Sanity check to keep you from breaking your system:"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
80 die "aborting to save your system" 111 die "aborting to save your system"
81 else 112 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 114 fi
84 fi 115 fi
85 116
86 if [[ "${PN}" == "qt-webkit" ]]; then 117 if [[ ${PN} == qt-webkit ]]; then
87 eshopts_push -s extglob 118 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then 119 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo 120 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage." 122 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug." 123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
93 ewarn "For more info check out bug #307861" 124 ewarn "For more info check out bug #307861"
94 echo 125 echo
95 fi 126 fi
96 eshopts_pop 127 eshopts_pop
97 fi 128 fi
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 138 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 140 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 141 fi
111 142
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then 143 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
122 fi 145 fi
123} 146}
124 147
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 149# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
129 152
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 154# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
133# tarball 156# Qt tarball.
134 157
135# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 159# @DESCRIPTION:
137# Unpacks the sources 160# Unpacks the sources.
138qt4-build_src_unpack() { 161qt4-build_src_unpack() {
139 setqtenv 162 setqtenv
140 local unpack_p="${MY_P}" 163
141 case "${PV}" in 164 case ${QT4_BUILD_TYPE} in
142 4.8.0_*) 165 live)
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 166 git-2_src_unpack
144 ;; 167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
174 targets+="${MY_P}/${target} "
175 done
176
177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
145 esac 181 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
149 ${QT4_EXTRACT_DIRECTORIES}; do
150 targets+=" ${unpack_p}/${target}"
151 done
152
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
155 case "${PV}" in
156 4.8.0_*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 182}
162 183
163# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
164# @DESCRIPTION: 186# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
167# example: 189# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
169# ${FILESDIR}"/mypatch2.patch"
170# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
171 196
172# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 198# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 201qt4-build_src_prepare() {
177 setqtenv 202 setqtenv
178 cd "${S}"
179 203
180 # fix qt 4.7 regression that skips -fvisibility=hidden 204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
181 if version_is_at_least "4.7.0_beta1"; then 208 if version_is_at_least 4.7; then
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi
186 # fix libx11 dependency on non X packages 209 # fix libX11 dependency on non X packages
187 if version_is_at_least "4.7.0_beta2"; then
188 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
189 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
190 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup 212
213 qt_assistant_cleanup
191 fi 214 fi
192 215
193 if use aqua; then 216 if use aqua; then
194 # provide a proper macx-g++-64 217 # provide a proper macx-g++-64
195 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
196 219
197 sed -e '/^CONFIG/s:app_bundle::' \ 220 sed -e '/^CONFIG/s:app_bundle::' \
198 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
199 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
200 fi 223 fi
201 224
202 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
203 skip_qmake_build_patch 226 skip_qmake_build
204 skip_project_generation_patch 227 skip_project_generation
205 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
206 fi 229 fi
207 230
208 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
209 # qmake bus errors with -O2 but -O3 works 232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
210 replace-flags -O2 -O3 234 replace-flags -O[23] -O1
211 fi 235 fi
212 236
213 # Bug 178652 237 # Bug 178652
214 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
215 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
216 append-flags -fno-gcse 240 append-flags -fno-gcse
217 fi 241 fi
218 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
219 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
220 if [[ $(gcc-major-version) -lt 4 ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
221 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
222 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
223 # Bug 253127 258 # Bug 253127
224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
225 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
226 fi 261 fi
227 262
228 # Bug 261632 263 # Bug 261632
229 if use ppc64; then 264 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc 266 append-flags -mminimal-toc
232 fi 267 fi
233 268
234 # Bug 282984 && Bug 295530 269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 270 sed -e "/^SYSTEM_VARIABLES=/i \
236 -i configure || die "sed qmake compilers failed" 271 CC='$(tc-getCC)'\n\
237 # bug 321335 272 CXX='$(tc-getCXX)'\n\
238 if version_is_at_least 4.6; then 273 CFLAGS='${CFLAGS}'\n\
239 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 274 CXXFLAGS='${CXXFLAGS}'\n\
240 xargs -0 \ 275 LDFLAGS='${LDFLAGS}'\n" \
241 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \ 276 -i configure \
242 -i || die "sed test compilers failed" 277 || die "sed SYSTEM_VARIABLES failed"
243 fi 278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
244 288
245 # Bug 172219 289 # Bug 172219
246 sed -e "s:X11R6/::" \ 290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
247 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
248 291
249 if [[ ${CHOST} == *-darwin* ]]; then 292 if [[ ${CHOST} == *-darwin* ]]; then
250 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
251 # crippled (by design) :/ 294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
252 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
253 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
254 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
255 -e "s:-arch\s\w*::g" \ 309 -e "s:-arch\s\w*::g" \
256 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
257 312
258 # Fix configure's -arch settings that appear in qmake/Makefile and also 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
259 # fix arch handling (automagically duplicates our -arch arg and breaks 314 # fix arch handling (automagically duplicates our -arch arg and breaks
260 # pch). Additionally disable Xarch support. 315 # pch). Additionally disable Xarch support.
316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
261 sed \ 320 sed \
262 -e "s:-arch i386::" \ 321 -e "s:-arch i386::" \
263 -e "s:-arch ppc::" \ 322 -e "s:-arch ppc::" \
264 -e "s:-arch x86_64::" \ 323 -e "s:-arch x86_64::" \
265 -e "s:-arch ppc64::" \ 324 -e "s:-arch ppc64::" \
266 -e "s:-arch \$i::" \ 325 -e "s:-arch \$i::" \
267 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
268 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
269 -e "s:-Xarch_x86_64::g" \ 328 -e "s:-Xarch_x86_64::g" \
270 -e "s:-Xarch_ppc64::g" \ 329 -e "s:-Xarch_ppc64::g" \
271 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
272 332
273 # On Snow Leopard don't fall back to 10.5 deployment target. 333 # On Snow Leopard don't fall back to 10.5 deployment target.
274 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
275 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
276 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
277 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
278 fi 339 fi
279 fi 340 fi
280 341
281 # this one is needed for all systems with a separate -liconv, apart from 342 # this one is needed for all systems with a separate -liconv, apart from
282 # Darwin, for which the sources already cater for -liconv 343 # Darwin, for which the sources already cater for -liconv
283 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
284 sed \ 345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
285 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
286 -i config.tests/unix/iconv/iconv.pro \ 346 -i config.tests/unix/iconv/iconv.pro \
287 || die "sed on iconv.pro failed" 347 || die "sed iconv.pro failed"
288 fi 348 fi
289 349
290 # we need some patches for Solaris 350 # we need some patches for Solaris
291 sed -i \
292 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
293 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
294 # use GCC over SunStudio 353 # use GCC over SunStudio
295 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
296 # don't flirt with non-Prefix stuff, we're quite possessive 355 # do not flirt with non-Prefix stuff, we're quite possessive
297 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
298 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
299 # strip predefined CFLAGS from qmake ( bug #312689 )
300 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
301 358
302 base_src_prepare 359 base_src_prepare
303} 360}
304 361
305# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
306# @DESCRIPTION: 363# @DESCRIPTION:
307# Default configure phase 364# Default configure phase
308qt4-build_src_configure() { 365qt4-build_src_configure() {
309 setqtenv 366 setqtenv
310 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
311 426
312 # this one is needed for all systems with a separate -liconv, apart from 427 # this one is needed for all systems with a separate -liconv, apart from
313 # Darwin, for which the sources already cater for -liconv 428 # Darwin, for which the sources already cater for -liconv
314 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
315 myconf+=" -liconv" 430 conf+=" -liconv"
431 fi
316 432
317 if has glib ${IUSE//+} && use glib; then 433 if use_if_iuse glib; then
318 # use -I, -L and -l from configure
319 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
320 # avoid the -pthread argument 435 # avoid the -pthread argument
321 myconf+=" ${glibflags//-pthread}" 436 conf+=" ${glibflags//-pthread}"
322 unset glibflags 437 unset glibflags
323 fi 438 fi
324 439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi
448
325 if use aqua ; then 449 if use aqua; then
326 # On (snow) leopard use the new (frameworked) cocoa code. 450 # On (snow) leopard use the new (frameworked) cocoa code.
327 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
328 myconf+=" -cocoa -framework" 452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
329 457
330 # We are crazy and build cocoa + qt3support :-) 458 # We are crazy and build cocoa + qt3support :-)
331 if use qt3support; then 459 if use qt3support; then
332 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
333 -i configure 461 -i configure || die
334 fi 462 fi
335 463 else
336 # We need the source's headers, not the installed ones. 464 conf+=" -no-framework"
337 myconf+=" -I${S}/include"
338
339 # Add hint for the framework location.
340 myconf+=" -F${QTLIBDIR}"
341 fi 465 fi
342 else 466 else
343 # freetype2 include dir is non-standard, thus include it on configure 467 # freetype2 include dir is non-standard, thus pass it to configure
344 # use -I from configure
345 myconf+=" $(pkg-config --cflags freetype2)" 468 conf+=" $(pkg-config --cflags-only-I freetype2)"
346 fi 469 fi
347 470
348 # Disable SSE4.x, since auto-detection is currently broken 471 conf+=" ${myconf}"
349 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 472 myconf=
350 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
351 473
352 echo ./configure ${myconf} 474 echo ./configure ${conf}
353 ./configure ${myconf} || die "./configure failed" 475 ./configure ${conf} || die "./configure failed"
354 myconf=""
355 476
356 prepare_directories ${QT4_TARGET_DIRECTORIES} 477 prepare_directories ${QT4_TARGET_DIRECTORIES}
357} 478}
358 479
359# @FUNCTION: qt4-build_src_compile 480# @FUNCTION: qt4-build_src_compile
367 488
368# @FUNCTION: qt4-build_src_test 489# @FUNCTION: qt4-build_src_test
369# @DESCRIPTION: 490# @DESCRIPTION:
370# Runs tests only in target directories. 491# Runs tests only in target directories.
371qt4-build_src_test() { 492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
372 for dir in ${QT4_TARGET_DIRECTORIES}; do 496 for dir in ${QT4_TARGET_DIRECTORIES}; do
373 emake -j1 check -C ${dir} 497 emake -j1 check -C ${dir}
374 done 498 done
375} 499}
376 500
377# @FUNCTION: fix_includes 501# @FUNCTION: fix_includes
378# @DESCRIPTION: 502# @DESCRIPTION:
379# For MacOSX we need to add some symlinks when frameworks are 503# For MacOS X we need to add some symlinks when frameworks are
380# being used, to avoid complications with some more or less stupid packages. 504# being used, to avoid complications with some more or less stupid packages.
381fix_includes() { 505fix_includes() {
382 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
383 # Some packages tend to include <Qt/...> 507 # Some packages tend to include <Qt/...>
384 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 508 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
385 509
386 # Fake normal headers when frameworks are installed... eases life later on 510 # Fake normal headers when frameworks are installed... eases life later on
387 local dest f 511 local dest f h
388 for frw in "${D}${QTLIBDIR}"/*.framework; do 512 for frw in "${D}${QTLIBDIR}"/*.framework; do
389 [[ -e "${frw}"/Headers ]] || continue 513 [[ -e "${frw}"/Headers ]] || continue
390 f=$(basename ${frw}) 514 f=$(basename ${frw})
391 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 515 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
392 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 516 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
404# @DESCRIPTION: 528# @DESCRIPTION:
405# Perform the actual installation including some library fixes. 529# Perform the actual installation including some library fixes.
406qt4-build_src_install() { 530qt4-build_src_install() {
407 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 531 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
408 setqtenv 532 setqtenv
533
409 install_directories ${QT4_TARGET_DIRECTORIES} 534 install_directories ${QT4_TARGET_DIRECTORIES}
410 install_qconfigs 535 install_qconfigs
411 fix_library_files 536 fix_library_files
412 fix_includes 537 fix_includes
538
413 # remove .la files since we are building only shared Qt libraries 539 # remove .la files since we are building only shared Qt libraries
414 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 540 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
415} 541}
416 542
417# @FUNCTION: setqtenv 543# @FUNCTION: setqtenv
544# @INTERNAL
418setqtenv() { 545setqtenv() {
419 # Set up installation directories 546 # Set up installation directories
420 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
421 QTPREFIXDIR=${EPREFIX}/usr 547 QTPREFIXDIR=${EPREFIX}/usr
422 QTBINDIR=${EPREFIX}/usr/bin 548 QTBINDIR=${EPREFIX}/usr/bin
423 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 549 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
424 QMAKE_LIBDIR_QT=${QTLIBDIR}
425 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 550 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
426 QTDATADIR=${EPREFIX}/usr/share/qt4
427 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 551 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
428 QTHEADERDIR=${EPREFIX}/usr/include/qt4 552 QTHEADERDIR=${EPREFIX}/usr/include/qt4
429 QTPLUGINDIR=${QTLIBDIR}/plugins 553 QTPLUGINDIR=${QTLIBDIR}/plugins
554 QTIMPORTDIR=${QTLIBDIR}/imports
555 QTDATADIR=${EPREFIX}/usr/share/qt4
556 QTTRANSDIR=${QTDATADIR}/translations
430 QTSYSCONFDIR=${EPREFIX}/etc/qt4 557 QTSYSCONFDIR=${EPREFIX}/etc/qt4
431 QTTRANSDIR=${QTDATADIR}/translations
432 QTEXAMPLESDIR=${QTDATADIR}/examples 558 QTEXAMPLESDIR=${QTDATADIR}/examples
433 QTDEMOSDIR=${QTDATADIR}/demos 559 QTDEMOSDIR=${QTDATADIR}/demos
560 QMAKE_LIBDIR_QT=${QTLIBDIR}
434 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 561 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
562
435 PLATFORM=$(qt_mkspecs_dir) 563 PLATFORM=$(qt_mkspecs_dir)
436 564
437 unset QMAKESPEC 565 unset QMAKESPEC
438}
439
440# @FUNCTION: standard_configure_options
441# @DESCRIPTION:
442# Sets up some standard configure options, like libdir (if necessary), whether
443# debug info is wanted or not.
444standard_configure_options() {
445 local myconf=
446
447 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
448
449 # Disable visibility explicitly if gcc version isn't 4
450 if [[ $(gcc-major-version) -lt 4 ]]; then
451 myconf+=" -no-reduce-exports"
452 fi
453
454 # precompiled headers doesn't work on hardened, where the flag is masked.
455 myconf+=" $(qt_use pch)"
456
457 if use debug; then
458 myconf+=" -debug"
459 else
460 myconf+=" -release"
461 fi
462 myconf+=" -no-separate-debug-info"
463
464 use aqua && myconf+=" -no-framework"
465
466 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
467 # $(tc-arch). Therefore we convert it to supported values.
468 case "$(tc-arch)" in
469 amd64|x64-*) myconf+=" -arch x86_64" ;;
470 ppc-macos) myconf+=" -arch ppc" ;;
471 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
472 sparc|sparc-*) myconf+=" -arch sparc" ;;
473 x86-macos) myconf+=" -arch x86" ;;
474 x86|x86-*) myconf+=" -arch i386" ;;
475 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
476 hppa|sh) myconf+=" -arch generic" ;;
477 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
478 esac
479
480 # 4.5: build everything but qt-xmlpatterns w/o exceptions
481 # 4.6: exceptions USE flag
482 local exceptions="-exceptions"
483 case "${PV}" in
484 4.5.*)
485 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
486 ;;
487 *)
488 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
489 ;;
490 esac
491
492 # note about -reduce-relocations:
493 # That flag seems to introduce major breakage to applications,
494 # mostly to be seen as a core dump with the message "QPixmap: Must
495 # construct a QApplication before a QPaintDevice" on Solaris
496 # -- Daniel Vergien
497 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
498
499 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
500 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
501 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
502 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
503 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
504 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
505 ${exceptions}
506 -nomake examples -nomake demos"
507
508 echo "${myconf}"
509} 566}
510 567
511# @FUNCTION: prepare_directories 568# @FUNCTION: prepare_directories
512# @USAGE: < directories > 569# @USAGE: < directories >
570# @INTERNAL
513# @DESCRIPTION: 571# @DESCRIPTION:
514# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 572# Generates Makefiles for the given list of directories.
515prepare_directories() { 573prepare_directories() {
516 for x in "$@"; do 574 for x in "$@"; do
517 pushd "${S}"/${x} >/dev/null 575 pushd "${S}"/${x} >/dev/null || die
518 einfo "running qmake in: $x" 576 einfo "Running qmake in: ${x}"
519 # avoid running over the maximum argument number, bug #299810 577 # avoid running over the maximum argument number, bug #299810
520 { 578 {
521 echo "${S}"/mkspecs/common/*.conf 579 echo "${S}"/mkspecs/common/*.conf
522 find "${S}" -name '*.pr[io]' 580 find "${S}" -name '*.pr[io]'
523 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 581 } | xargs sed -i \
582 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
583 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
584 || die
524 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 585 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
525 popd >/dev/null 586 popd >/dev/null || die
526 done 587 done
527} 588}
528 589
529 590
530# @FUNCTION: build_directories 591# @FUNCTION: build_directories
531# @USAGE: < directories > 592# @USAGE: < directories >
593# @INTERNAL
532# @DESCRIPTION: 594# @DESCRIPTION:
533# Compiles the code in $QT4_TARGET_DIRECTORIES 595# Compiles the code in the given list of directories.
534build_directories() { 596build_directories() {
535 for x in "$@"; do 597 for x in "$@"; do
536 pushd "${S}"/${x} >/dev/null 598 pushd "${S}"/${x} >/dev/null || die
537 emake CC="$(tc-getCC)" \ 599 emake CC="$(tc-getCC)" \
538 CXX="$(tc-getCXX)" \ 600 CXX="$(tc-getCXX)" \
539 LINK="$(tc-getCXX)" || die "emake failed" 601 LINK="$(tc-getCXX)" || die "emake failed"
540 popd >/dev/null 602 popd >/dev/null || die
541 done 603 done
542} 604}
543 605
544# @FUNCTION: install_directories 606# @FUNCTION: install_directories
545# @USAGE: < directories > 607# @USAGE: < directories >
608# @INTERNAL
546# @DESCRIPTION: 609# @DESCRIPTION:
547# run emake install in the given directories, which are separated by spaces 610# Runs emake install in the given directories, which are separated by spaces.
548install_directories() { 611install_directories() {
549 for x in "$@"; do 612 for x in "$@"; do
550 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 613 pushd "${S}"/${x} >/dev/null || die
551 emake INSTALL_ROOT="${D}" install || die "emake install failed" 614 emake INSTALL_ROOT="${D}" install || die "emake install failed"
552 popd >/dev/null || die "Can't popd from ${S}/${x}" 615 popd >/dev/null || die
553 done 616 done
554} 617}
555 618
556# @ECLASS-VARIABLE: QCONFIG_ADD 619# @ECLASS-VARIABLE: QCONFIG_ADD
557# @DESCRIPTION: 620# @DESCRIPTION:
567# @DESCRIPTION: 630# @DESCRIPTION:
568# List variables that should be defined at the top of QtCore/qconfig.h 631# List variables that should be defined at the top of QtCore/qconfig.h
569: ${QCONFIG_DEFINE:=} 632: ${QCONFIG_DEFINE:=}
570 633
571# @FUNCTION: install_qconfigs 634# @FUNCTION: install_qconfigs
635# @INTERNAL
572# @DESCRIPTION: 636# @DESCRIPTION:
573# Install gentoo-specific mkspecs configurations 637# Install gentoo-specific mkspecs configurations.
574install_qconfigs() { 638install_qconfigs() {
575 local x 639 local x
576 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 640 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
577 for x in QCONFIG_ADD QCONFIG_REMOVE; do 641 for x in QCONFIG_ADD QCONFIG_REMOVE; do
578 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 642 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
589 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 653 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
590 fi 654 fi
591} 655}
592 656
593# @FUNCTION: generate_qconfigs 657# @FUNCTION: generate_qconfigs
658# @INTERNAL
594# @DESCRIPTION: 659# @DESCRIPTION:
595# Generates gentoo-specific configurations 660# Generates gentoo-specific qconfig.{h,pri}.
596generate_qconfigs() { 661generate_qconfigs() {
597 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 662 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
598 local x qconfig_add qconfig_remove qconfig_new 663 local x qconfig_add qconfig_remove qconfig_new
599 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 664 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
600 [[ -f ${x} ]] || continue 665 [[ -f ${x} ]] || continue
601 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 666 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
602 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 667 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
649 fi 714 fi
650} 715}
651 716
652# @FUNCTION: qt4-build_pkg_postrm 717# @FUNCTION: qt4-build_pkg_postrm
653# @DESCRIPTION: 718# @DESCRIPTION:
654# Generate configurations when the package is completely removed 719# Regenerate configuration when the package is completely removed.
655qt4-build_pkg_postrm() { 720qt4-build_pkg_postrm() {
656 generate_qconfigs 721 generate_qconfigs
657} 722}
658 723
659# @FUNCTION: qt4-build_pkg_postinst 724# @FUNCTION: qt4-build_pkg_postinst
660# @DESCRIPTION: 725# @DESCRIPTION:
661# Generate configuration, plus throws a message about possible 726# Regenerate configuration, plus throw a message about possible
662# breakages and proposed solutions. 727# breakages and proposed solutions.
663qt4-build_pkg_postinst() { 728qt4-build_pkg_postinst() {
664 generate_qconfigs 729 generate_qconfigs
665} 730}
666 731
667# @FUNCTION: skip_qmake_build_patch 732# @FUNCTION: skip_qmake_build
733# @INTERNAL
668# @DESCRIPTION: 734# @DESCRIPTION:
669# Don't need to build qmake, as it's already installed from qt-core 735# Patches configure to skip qmake compilation, as it's already installed by qt-core.
670skip_qmake_build_patch() { 736skip_qmake_build() {
671 # Don't need to build qmake, as it's already installed from qt-core
672 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 737 sed -i -e "s:if true:if false:g" "${S}"/configure || die
673} 738}
674 739
675# @FUNCTION: skip_project_generation_patch 740# @FUNCTION: skip_project_generation
741# @INTERNAL
676# @DESCRIPTION: 742# @DESCRIPTION:
677# Exit the script early by throwing in an exit before all of the .pro files are scanned 743# Exit the script early by throwing in an exit before all of the .pro files are scanned.
678skip_project_generation_patch() { 744skip_project_generation() {
679 # Exit the script early by throwing in an exit before all of the .pro files are scanned
680 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 745 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
681 -i "${S}"/configure || die "Sed failed"
682} 746}
683 747
684# @FUNCTION: symlink_binaries_to_buildtree 748# @FUNCTION: symlink_binaries_to_buildtree
749# @INTERNAL
685# @DESCRIPTION: 750# @DESCRIPTION:
686# Symlink generated binaries to buildtree so they can be used during compilation 751# Symlinks generated binaries to buildtree, so they can be used during compilation time.
687# time
688symlink_binaries_to_buildtree() { 752symlink_binaries_to_buildtree() {
689 for bin in qmake moc uic rcc; do 753 for bin in qmake moc uic rcc; do
690 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 754 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
691 done 755 done
692} 756}
693 757
694# @FUNCTION: fix_library_files 758# @FUNCTION: fix_library_files
759# @INTERNAL
695# @DESCRIPTION: 760# @DESCRIPTION:
696# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 761# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
697# moves the *.pc-files into the pkgconfig directory 762# moves the *.pc files into the pkgconfig directory.
698fix_library_files() { 763fix_library_files() {
764 local libfile
699 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 765 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
700 if [[ -e ${libfile} ]]; then 766 if [[ -e ${libfile} ]]; then
701 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 767 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
702 fi 768 fi
703 done 769 done
704 770
705 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 771 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
706 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 772 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
707 if [[ -e ${libfile} ]]; then 773 if [[ -e ${libfile} ]]; then
708 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 774 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
709 775
710 # Move .pc files into the pkgconfig directory 776 # Move .pc files into the pkgconfig directory
711 dodir ${QTPCDIR#${EPREFIX}} 777 dodir ${QTPCDIR#${EPREFIX}}
712 mv ${libfile} "${D}"/${QTPCDIR}/ \ 778 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
713 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
714 fi 779 fi
715 done 780 done
716 781
717 # Don't install an empty directory 782 # Don't install an empty directory
718 rmdir "${D}"/${QTLIBDIR}/pkgconfig 783 rmdir "${D}"/${QTLIBDIR}/pkgconfig
719} 784}
720 785
721# @FUNCTION: qt_use 786# @FUNCTION: qt_use
722# @USAGE: < flag > [ feature ] [ enableval ] 787# @USAGE: < flag > [ feature ] [ enableval ]
723# @DESCRIPTION: 788# @DESCRIPTION:
724# This will echo "${enableval}-${feature}" if <flag> is enabled, or 789# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
725# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 790# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
726# will be used for that. If [enableval] is not specified, it omits the 791# will be used for that. If [enableval] is not specified, it omits the
727# assignment-part 792# "-${enableval}" part.
728qt_use() { 793qt_use() {
729 local flag=$1 794 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
730 local feature=$1
731 local enableval=
732
733 [[ -n $2 ]] && feature=$2
734 [[ -n $3 ]] && enableval=-$3
735
736 if use ${flag}; then
737 echo "${enableval}-${feature}"
738 else
739 echo "-no-${feature}"
740 fi
741} 795}
742 796
743# @FUNCTION: qt_mkspecs_dir 797# @FUNCTION: qt_mkspecs_dir
744# @RETURN: the specs-directory w/o path 798# @RETURN: the specs-directory w/o path
745# @DESCRIPTION: 799# @DESCRIPTION:
746# Allows us to define which mkspecs dir we want to use. 800# Allows us to define which mkspecs dir we want to use.
747qt_mkspecs_dir() { 801qt_mkspecs_dir() {
748 # Allows us to define which mkspecs dir we want to use.
749 local spec 802 local spec=
750 803
751 case ${CHOST} in 804 case "${CHOST}" in
752 *-freebsd*|*-dragonfly*) 805 *-freebsd*|*-dragonfly*)
753 spec=freebsd ;; 806 spec=freebsd ;;
754 *-openbsd*) 807 *-openbsd*)
755 spec=openbsd ;; 808 spec=openbsd ;;
756 *-netbsd*) 809 *-netbsd*)
767 *-solaris*) 820 *-solaris*)
768 spec=solaris ;; 821 spec=solaris ;;
769 *-linux-*|*-linux) 822 *-linux-*|*-linux)
770 spec=linux ;; 823 spec=linux ;;
771 *) 824 *)
772 die "Unknown CHOST, no platform choosen." 825 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
773 esac 826 esac
774 827
775 CXX=$(tc-getCXX) 828 case "$(tc-getCXX)" in
776 if [[ ${CXX} == *g++* ]]; then 829 *g++*)
777 spec+=-g++ 830 spec+=-g++ ;;
778 elif [[ ${CXX} == *icpc* ]]; then 831 *icpc*)
779 spec+=-icc 832 spec+=-icc ;;
780 else 833 *)
781 die "Unknown compiler ${CXX}." 834 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
782 fi 835 esac
783 if [[ -n ${LIBDIR/lib} ]]; then
784 spec+=-${LIBDIR/lib}
785 fi
786 836
787 # Add -64 for 64bit profiles 837 # Add -64 for 64bit profiles
788 if use x64-freebsd || 838 if use x64-freebsd ||
789 use amd64-linux || 839 use amd64-linux ||
790 use x64-macos || 840 use x64-macos ||
796 846
797 echo "${spec}" 847 echo "${spec}"
798} 848}
799 849
800# @FUNCTION: qt_assistant_cleanup 850# @FUNCTION: qt_assistant_cleanup
801# @RETURN: nothing 851# @INTERNAL
802# @DESCRIPTION: 852# @DESCRIPTION:
803# Tries to clean up tools.pro for qt-assistant ebuilds 853# Tries to clean up tools.pro for qt-assistant ebuilds.
804# Meant to be called in src_prepare 854# Meant to be called in src_prepare().
855# Since Qt 4.7.4 this function is a no-op.
805qt_assistant_cleanup() { 856qt_assistant_cleanup() {
857 # apply patching to qt-assistant ebuilds only
858 [[ ${PN} != qt-assistant ]] && return
859
860 # no longer needed for 4.7.4 and later
861 version_is_at_least 4.7.4 && return
862
806 # different versions (and branches...) may need different handling, 863 # different versions (and branches...) may need different handling,
807 # add a case if you need special handling 864 # add a case if you need special handling
808 case "${MY_PV_EXTRA}" in 865 case "${MY_PV_EXTRA}" in
809 *kde-qt*) 866 *kde-qt*)
810 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \ 867 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819 ;; 876 ;;
820 esac 877 esac
821} 878}
822 879
823# @FUNCTION: qt_nolibx11 880# @FUNCTION: qt_nolibx11
824# @RETURN: nothing 881# @INTERNAL
825# @DESCRIPTION: 882# @DESCRIPTION:
826# Ignore X11 tests for packages that don't need X libraries installed 883# Ignore X11 tests for packages that don't need X libraries installed.
827qt_nolibx11() { 884qt_nolibx11() {
828 einfo "removing X11 check to allow X-less compilation"
829 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 885 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
830 die "x11 check sed failed" 886 die "x11 check sed failed"
831} 887}
832 888
833EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 889EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.95  
changed lines
  Added in v.1.125

  ViewVC Help
Powered by ViewVC 1.1.20